/**
 * Create an middleware function
 * @function apemanMiddlewareReact
 * @param {Object} [options={}] - Optional settings
 * @returns {function}
 */
'use strict'

const co = require('co')
const { markup } = require('breact')
const debug = require('debug')('apeman:middleware:react')

/** @lends apemanMiddlewareReact */
function create (options = {}) {
  debug('created')

  function serveReactMarkup (Component, props, ...children) {
    return markup(Component, props, children)
  }

  return co.wrap(function * apemanMiddlewareReact (ctx, next) {
    ctx.react = ctx.react || serveReactMarkup
    yield next()
  })
}

module.exports = create
